program Sorting;
uses wincrt;
const
  arr_size=25;
type
  arr_type=array [1..arr_size] of real;
  arr_type_spec=array [0..arr_size] of real;
  arr_type_Shell_sec=array [-9..arr_size] of real;
var
  i,j,k:integer;
  x,w:real;
  YN:1..2;

procedure swap_real(var x1,x2:real);
begin
x:=x1; x1:=x2; x2:=x;
end;

procedure exchange_sort(var a:arr_type);
begin
for i:=2 to arr_size do
  for j:=arr_size downto i do
    if a[j-1]>a[j] then begin
      swap_real(a[j-1],a[j]);
    end;
end;

procedure Sheiker(var a:arr_type;L,R,K1:integer);
begin
repeat
  for j:=R downto L do if a[j-1]>a[j] then begin
    swap_real(a[j-1],a[j]);
    K1:=j;
  end;
  L:=K1+1;
  for j:=L to R do if a[j-1]>a[j] then begin
    swap_real(a[j-1],a[j]);
    K1:=j;
  end;
R:=K1-1;
until L>R;
end;

procedure fixing_sort(var a:arr_type_spec);
begin
for i:=2 to arr_size do begin
  x:=a[i]; {       }
  a[0]:=x; {   !  [0..arr_size]! }
  j:=i; {      }
   while x<a[j-1] do begin
     a[j]:=a[j-1]; {      1   }
     j:=j-1; {   }
   end;
  a[j]:=x;
end;
end;

procedure direct_choise(var a:arr_type);
begin
for i:=1 to arr_size-1 do begin
  k:=i; {     }
  x:=a[i];
  for j:=i+1 to arr_size do {     }
    if a[j]<x then begin
      k:=j; x:=a[k];
    end;
  a[k]:=a[i]; a[i]:=x; {    }
  end;
end;

procedure Shell_sort(var a:arr_type);
var
  m:integer; {   }
begin
m:=arr_size;
while m>=1 do begin {    }
  m:=m div 2;
  for i:=m+1 to arr_size do begin {      }
    x:=a[i]; {    }
    j:=i-m;
    while (j>=1) and (x<a[j]) do begin {   }
      a[j+m]:=a[j]; j:=j-m;
    end;
    a[j+m]:=x; {      }
    end;
  end;
end;

procedure Shell_sort_second(var a:arr_type_Shell_sec);
const
  t=4; {   }
  h:array [1..t] of integer=(9,5,3,1);
var
  s:integer; {   }
  m:1..t;
begin
for m:=1 to t do begin {   }
  k:=h[m]; {    }
  s:=-k; {    }
  for i:=k+1 to arr_size do begin {   }
    x:=a[i]; {    }
    j:=i-k; {  }
    if s=0 then s:=-k; {        }
    s:=s+1; a[s]:=x; {   }
    while x<a[j] do begin {    }
      a[j+k]:=a[j]; {     }
      j:=j-k;
    end;
  end;
end;
end;

procedure Quick_Sort(var a:arr_type);
const
  M=12;  { -    }
var
  S:0..M; {    (  ) }
  L,R:integer; {  /  }
  stack:array [1..M] of record          {        }
                          L,R:integer;  {   }
                        end;            {                    }
Begin
s:=1; {     }
stack[s].L:=1; {    }
stack[s].R:=arr_size; {    }
repeat {        }
  L:=stack[s].L; R:=stack[s].R; {   }
  s:=s-1;
  repeat {  a[L]..a[R]   }
    i:=L; j:=R;
    x:=a[(L+R) div 2]; {    }
    repeat { .      }
      while a[i]<x do i:=i+1; {        }
      while x<a[j] do j:=j+1; {  /  }
      if i<=j then begin
        swap_real(a[i],a[j]);
        inc(i); dec(j);
      end;
    until i>j; {  }
    if i<R then begin {    -    }
      inc(s);
      stack[s].L:=i;  stack[s].R:=R;
    end;
    R:=j;
  until L>=R;
until s=0;
End;

procedure Quick_Sort_R(var a:arr_type);
  procedure Sort(L,R:integer);
  begin
  i:=L; j:=R;
  x:=a[(i+R) div 2];
  repeat
    while a[i]<x do inc(i);
    while x<a[j] do dec(j);
    if i<j then begin
      swap_real(a[i],a[j]);
      inc(i); dec(j);
    end; {if}
  until i>j;
  if L<j then Sort(L,j);
  if i<R then Sort(i,R);
  end; {Sort}
Begin
Sort(1,arr_size);
End; {Quick_Sort_R}


Begin
write('   ? (1- 2-)');
readln(YN);
case YN of
  1:begin
    writeln('   sorting.tpu');
    writeln('1 - exchange_sort(var a:arr_type); -  ');
    writeln('2 - Sheiker(var a:arr_type;L,R,K1:integer); -  ');
    writeln('3 - fixing_sort(var a:arr_type_spec); -  ');
    writeln('4 - direct_choise(var a:arr_type); -     ');
    writeln('5 - Shell_sort(var a:arr_type); -   ( )');
    writeln('6 - Shell_sort_second(var a:arr_type_Shell_sec); -   ( )');
    writeln('7 - Quick_Sort(var a:arr_type); -  ');
    writeln('8 - Quick_Sort_R(var a:arr_type); -   ( )');
  end;
else
  writeln(' !    !');
end;
end.