unit Sorting;

interface
const
  arr_size=25;
type
  arr_type=array [1..arr_size] of real;
  arr_type_spec=array [0..arr_size] of real;
  arr_type_Shell_sec=array [-9..arr_size] of real;
var
  i,j,k:integer;
  x,w:real;
  YN:1..2;
procedure swap_real(var x1,x2:real);
procedure exchange_sort(var a:arr_type);
procedure Sheiker(var a:arr_type;L,R,K1:integer);
procedure fixing_sort(var a:arr_type_spec);
procedure direct_choise(var a:arr_type);
procedure Shell_sort(var a:arr_type);
procedure Shell_sort_second(var a:arr_type_Shell_sec);
procedure Quick_Sort(var a:arr_type);
procedure Quick_Sort_R(var a:arr_type);

implementation

procedure swap_real;
begin
x:=x1; x1:=x2; x2:=x;
end;

procedure exchange_sort;
begin
for i:=2 to arr_size do
  for j:=arr_size downto i do
    if a[j-1]>a[j] then begin
      swap_real(a[j-1],a[j]); {x:=a[j-1]; a[j-1]:=a[j]; a[j]:=x;}
    end;
end;

procedure Sheiker;
begin
repeat
  for j:=R downto L do if a[j-1]>a[j] then begin
    swap_real(a[j-1],a[j]);
    K1:=j;
  end;
  L:=K1+1;
  for j:=L to R do if a[j-1]>a[j] then begin
    swap_real(a[j-1],a[j]);
    K1:=j;
  end;
R:=K1-1;
until L>R;
end;

procedure fixing_sort;
begin
for i:=2 to arr_size do begin
  x:=a[i]; { 뢠  ᯮ⥫ ६ ⥪騩  }
  a[0]:=x; { ⠢  !ᨢ  [0..arr_size]! }
  j:=i; {  ⠢  ᯮ⥫ ६ }
   while x<a[j-1] do begin
     a[j]:=a[j-1]; { ६饭  ஢ ⮢  1  ࠢ }
     j:=j-1; {  ⠢ }
   end;
  a[j]:=x;
end;
end;

procedure direct_choise;
begin
for i:=1 to arr_size-1 do begin
  k:=i; {   쭮  }
  x:=a[i];
  for j:=i+1 to arr_size do {  㬠  ⪥ }
    if a[j]<x then begin
      k:=j; x:=a[k];
    end;
  a[k]:=a[i]; a[i]:=x; {  ⠬  }
  end;
end;

procedure Shell_sort;
var
  m:integer; { 稭 蠣 }
begin
m:=arr_size;
while m>=1 do begin { 横  蠣 }
  m:=m div 2;
  for i:=m+1 to arr_size do begin { ஢ ᨢ  ⥪騬 蠣 }
    x:=a[i]; {  ⥪騩  }
    j:=i-m;
    while (j>=1) and (x<a[j]) do begin { 横 ᪠ }
      a[j+m]:=a[j]; j:=j-m;
    end;
    a[j+m]:=x; { ⠢   㦭  }
    end;
  end;
end;

procedure Shell_sort_second;
const
  t=4; { ⢮ 蠣 }
  h:array [1..t] of integer=(9,5,3,1);
var
  s:integer; {   }
  m:1..t;
begin
for m:=1 to t do begin {  蠣 }
  k:=h[m]; { 뢠 ⥪騩 蠣 }
  s:=-k; { ।塞   }
  for i:=k+1 to arr_size do begin { ஢ ᨢ }
    x:=a[i]; { 뢠  ⠢ }
    j:=i-k; {  }
    if s=0 then s:=-k; {   ᨢ ஢   ࠧ }
    s:=s+1; a[s]:=x; { ⠢  }
    while x<a[j] do begin {   ⠢ }
      a[j+k]:=a[j]; { ᢮   ⠢ }
      j:=j-k;
    end;
  end;
end;
end;

procedure Quick_Sort;
const
  M=12;  { - ⮢ ᨢ ⥪ }
var
  S:0..M; { ⬥⪠ 設 ⥪ ( ᫥ ) }
  L,R:integer; { ࠭ /ࠢ  }
  stack:array [1..M] of record          { 砫       }
                          L,R:integer;  { ࠢ ᨢ }
                        end;            {                    }
Begin
s:=1; { ⠪  ⥪  }
stack[s].L:=1; {  砫 ᨢ }
stack[s].R:=arr_size; { ᫮ ⮢ ᨢ }
repeat { ந 롮  ⥪ ᫥ 񭭮 ଠ樨 }
  L:=stack[s].L; R:=stack[s].R; { 뢠 ࠭ }
  s:=s-1;
  repeat {  a[L]..a[R]  ᨢ }
    i:=L; j:=R;
    x:=a[(L+R) div 2]; { 롨ࠥ ।  }
    repeat { . ᬮ ᨢ   ⠬ }
      while a[i]<x do i:=i+1; { ᬮ       }
      while x<a[j] do j:=j+1; { ᫥ / ࠢ }
      if i<=j then begin
        swap_real(a[i],a[j]);
        inc(i); dec(j);
      end;
    until i>j; {ᬮ ⨫ }
    if i<R then begin {   ⥪ -樨  ௠  }
      inc(s);
      stack[s].L:=i;  stack[s].R:=R;
    end;
    R:=j;
  until L>=R;
until s=0;
End;

procedure Quick_Sort_R;
  procedure Sort(L,R:integer);
  begin
  i:=L; j:=R;
  x:=a[(i+R) div 2];
  repeat
    while a[i]<x do inc(i);
    while x<a[j] do dec(j);
    if i<j then begin
      swap_real(a[i],a[j]);
      inc(i); dec(j);
    end; {if}
  until i>j;
  if L<j then Sort(L,j);
  if i<R then Sort(i,R);
  end; {Sort}
Begin
Sort(1,arr_size);
End; {Quick_Sort_R}


Begin
write('뢥 ᠭ 楤  sorting.tpu ? (1-  2-)');
readln(YN);
case YN of
  1:begin
    writeln('ᠭ 楤  sorting.tpu');
    writeln('exchange_sort(var a:arr_type); -  ஢');
    writeln('Sheiker(var a:arr_type;L,R,K1:integer); - ୠ ஢');
    writeln('fixing_sort(var a:arr_type_spec); - ஢ ⠢');
    writeln('direct_choise(var a:arr_type); - ஢   אַ 롮');
    writeln('Shell_sort(var a:arr_type); - ஢  (᪠ )');
    writeln('Shell_sort_second(var a:arr_type_Shell_sec); - ஢  (ன ਠ)');
    writeln('Quick_Sort(var a:arr_type); -  ஢');
    writeln('Quick_Sort_R(var a:arr_type); -  ஢ ( ४ᨪ)');
    writeln(' - ');
    writeln(' - ');
    writeln('');
  end;
else
  writeln(' ७! 祣  㤥 뢥!');
end;
end.